/**********************************************************************
 *		ls ǂ
 **********************************************************************
 */
#include <stdio.h>
#include <malloc.h>
#include <stat.h>
#include <conslib.h>

#if	0
static char USAGE[]=
"Usage:\n"
"%% ls [-Option] [ dirname | matching-pattern ]\n"
"Option:\n"
"  -a   do not hide 'HIDDEN' files.\n"
"  -R   list subdirectories recursively.\n"
"  -F   Find file.\n"
"  -f   skip sort by name.\n"
"  -o   Sort by filesize.\n"
"  -r   sort in reverse order.\n"
"  -l   use a long listing format\n"
"  -1   list one file per line\n"
"  -d   'du' mode ( calculate filesize recursively )\n"
"\n"
;

#else

static char USAGE[]=
"Usage:\n"
"%% ls [-Option] [ dirname | matching-pattern ]\n"
"Option:\n"
"  -a   ׂẴt@C\.(rbg\)\n"
"  -R   TufBNg.\n"
"  -F   t@C.(݃fBNgȉɂ)\n"
"  -l   `ŕ\.\n"
"  -f   t@CŃ\[gȂ.\n"
"  -o   t@CTCYŃ\[g.\n"
"  -r   \[gʂtɂ.\n"
"  -1   PsɂPt@C\.\n"
"  -d   TufBNg̗eʂvZĕ\.\n"
"\n"
;
#endif

//	showmode :
#define	NOSHOW	 0	//	\
#define	SHOW	 1	//	\
#define DIRONLY  2	//	fBNĝݏ
#define FILEONLY 4	//	t@Ĉݏ
#define DIRFILE  6	//	fBNgƃt@C̗


#define	ScreenWidthMAX	128
#define	ScreenHeightMAX	 32
#define Getopt(argc,argv)  \
 {int i;char *s;for(i=0;i<128;i++) opt[i]=NULL; \
   while( ( argc>1 )&&( *argv[1]=='-') ) \
    { s=argv[1];while(*(++s)) {opt[ *s & 0x7f ] = (s+1) ;} argc--;argv++; } \
 }

#define IsOpt(c) ((opt[ c & 0x7f ])!=NULL)
#define   Opt(c)   opt[ c & 0x7f ]

int sjis2TCHAR( const BYTE *src, LPTSTR dst, DWORD max );
unsigned int dirSpace( const char *dir,const char *name ,int showmode);
char *xstrdup(char *string);

/**********************************************************************
 *	[Jȃ[NGA.
 **********************************************************************
 */
static int	ScreenWidth =80;
static int	ScreenHeight=12;
static char *opt[128];		// IvVIĂ΁A̒̕ւ̃|C^.
static char recurse=0;		// 1:fBNgċA.
static char nocolumn=0;		// 1:\ɂPsɕ\.
static char allattr=0;		// 1:B̃t@C\.
static int  files=0;		// t@C.

#define	MAX_STACK	1440	// PfBNgɋt@C̍ő.

static char *outstack[MAX_STACK];	//\[gJ\̂߂̗.
static int   outidx;				//outstack[]̌ݓo^.
static int   outwmax;				//outstack[]̒̒̌̕ݍől.
static int	 sidx;					//\[gL[̃ItZbg.
/**********************************************************************
 *	gp@.
 **********************************************************************
 */
static void Usage(void)
{
	fprintf(stderr,USAGE);
	exit(1);
}

/**********************************************************************
 *	.
 **********************************************************************
 */
static int unicode2sjis( LPCTSTR src, BYTE *dst, DWORD max )
{
	return WideCharToMultiByte( CP_ACP, 0, src, -1, dst, dst ? max : 0, NULL, NULL ) ;
}
static int sjis2TCHAR( const BYTE *src, LPTSTR dst, DWORD max )
{
	return MultiByteToWideChar( CP_ACP, 0, src, -1, dst, dst ? max / sizeof (TCHAR) : 0  ) ;
}


/**********************************************************************
 *	u2a a2u 260oCg܂. ߂ĺ̕ARs[Ďg.
 **********************************************************************
 */
static char *u2a(TCHAR *src)
{
	static char u2abuf[_MAX_PATH];
	unicode2sjis( src,u2abuf,_MAX_PATH );
	return u2abuf;
}

static TCHAR *a2u(char *src)
{
	static TCHAR a2ubuf[_MAX_PATH];
	sjis2TCHAR( src,a2ubuf,_MAX_PATH );
	return a2ubuf;
}

static void init_obuf(void)
{
	outidx = 0;
	outwmax = 0;
}

static void spcprint(int n)
{
	int i;
	for(i=0;i<n;i++) {
		printf(" ");
	}
}

static int to_upper(int c)
{
	if( (c >= 'a') && (c <= 'z') ) return c - 0x20;
	return c;
}

static int stricmp(unsigned char *s,unsigned char *t)
{
	int cs,ct;
	while(*s) {
		cs = to_upper(*s++);
		ct = to_upper(*t++);
		if(cs != ct) return cs - ct;
	}
	return *s - *t;
}


int comp(int i,int j)
{
	int rc;
//	printf("comp(a[%d],a[%d])\n",i,j);
	rc = stricmp( outstack[i] + sidx , outstack[j] + sidx );
	
	if(IsOpt('r')) rc = (-rc);	//t\[g.
	return rc;
}

void exch(int i,int j)
{
	char *t;
//	printf("exch(%d,%d)\n",i,j);

	t=outstack[i];
	  outstack[i] =outstack[j];
				   outstack[j]=t;
}

static void sort_obuf(void)
{
	extern void combsort(int size,int (*comp)(),void (*exch)());

	sidx=0;
	if(IsOpt('l')) {	//`̂,
		sidx = 26;
		if(IsOpt('o')) {	// Sort by Size.
			sidx = 15;
		}
		if(IsOpt('a')) {	// with Attrib
			sidx += 5;
		}
	}
	combsort(outidx,comp,exch);
}


static void flush_obuf(void)
{
	int i;
	int nw,cnt;

	if(!IsOpt('f')) sort_obuf();

	if( nocolumn ) {
		for(i=0;i<outidx;i++) {
			printf("%s\n",outstack[i]);	//PsɂP.
		}
	}else{
		nw = (ScreenWidth-1) / (outwmax+2);	//Psɉ邩.
		cnt = 0;
		for(i=0;i<outidx;i++) {
			printf("%s",outstack[i]);spcprint(outwmax+2 - strlen(outstack[i]));
			cnt++;
			if(cnt >= nw) {
				printf("\n");cnt=0;
			}
		}
		if(cnt)
			printf("\n");
	}
	
	for(i=0;i<outidx;i++) {
		free(outstack[i]);
	}
	init_obuf();
}

static void push_obuf(char *s)
{
	int len;

	outstack[outidx++] = xstrdup(s);
	if(outidx >= MAX_STACK) {
		fprintf(stderr,"ls: memory exhausted\n");exit(-1);
	}
	
	len = strlen(s);
	if(	outwmax < len)
		outwmax = len;
}

/**********************************************************************
 *		
 **********************************************************************
 */
void add_comma(char *t,char *s,int n)
{
	int l = strlen(s);	//.
	int i;
	int digit=0;
	char *p;
	p=t+n;
	*p=0;
	
	for(i=l-1;i>=0;i--,digit++) {
		if( (digit!=0) && (digit % 3)==0 ) {
			*(--p) = ',';
		}
		*(--p) = s[i];
	}
	while(p>t) {
		*(--p) = ' ';
	}
}

/**********************************************************************
 *		
 **********************************************************************
 */
void totalPrint(int sp)
{
	char  fsizef0[16];
	char  fsizef1[16];
	sprintf(fsizef0,"%d",sp);	//POiPrint.

	add_comma(fsizef1,fsizef0,10+4);	//RÂJ}؂.
//	if(IsOpt('l')) {
//		printf("                    ");
//	}
	printf("#%4d file(s)%s bytes.\n",files,fsizef1+2);
}

/**********************************************************************
 *		
 **********************************************************************
 */
void dirPrint(WIN32_FIND_DATA *fd,const char *dirname,int sp)
{
	char  fname[_MAX_PATH];	// ASCIIł̃t@C.
	char  prbuf[_MAX_PATH];
	char  fsizef0[16];
	char  fsizef1[16];
	char  fatr[8];
	char  timestamps[32];
	char  *fdir;
	char  *t;
	SYSTEMTIME systime;
	FILETIME   localft;

	//Bt@C̕\}.
	if( ( allattr == 0 ) && ( fd->dwFileAttributes & FILE_ATTRIBUTE_HIDDEN ) ) return;
	// du [h̎͒ʏt@C\.
	if( IsOpt('d') && ((fd->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )==0) ) return;

	//t@C     ===> fname[]
	if(IsOpt('F')) {	// -F IvV̓tpX.
		strcpy(fname,dirname);t = fname + strlen(fname);
		unicode2sjis(fd->cFileName , t , _MAX_PATH );
	}else{
		unicode2sjis(fd->cFileName , fname , _MAX_PATH );
	}
	//t@CTCY ===> fsizef1[]
	sprintf(fsizef0,"%d",sp);	//POiPrint.
	add_comma(fsizef1,fsizef0,10+4);	//RÂJ}؂.
	
	// -a IvV̂݁A\.
	fatr[0]=0;
	if( allattr ) {
	//t@C   ===> fatr[]
	strcpy(fatr," ----");
	if( fd->dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE   ) fatr[1]='A';
	if( fd->dwFileAttributes & FILE_ATTRIBUTE_SYSTEM    ) fatr[2]='S';
	if( fd->dwFileAttributes & FILE_ATTRIBUTE_HIDDEN    ) fatr[3]='H';
	if( fd->dwFileAttributes & FILE_ATTRIBUTE_READONLY  ) fatr[4]='R';
	}
	
	//fBNg   ===> fdir[]
	if((fd->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )&&(!IsOpt('d'))) {
		fdir="  <DIR>    ";
	}else{
		fdir=fsizef1+3;
		files++;
	}
	//t           ===> timestamps[]
	FileTimeToLocalFileTime(&fd->ftLastWriteTime,&localft);	//^CX^v[Jɒ.
	FileTimeToSystemTime(&localft,&systime);				//yy,mm,dd̒lɕϊ.
	sprintf(timestamps,"%02d-%02d-%02d %02d:%02d",			//󎚂.
		systime.wYear % 100,
		systime.wMonth	,
		systime.wDay	,
		systime.wHour	,
		systime.wMinute
	);

	//\F(\X^bNւ̐ςݍ)
	if(IsOpt('l')) {
		sprintf(prbuf,"%s%s%s %s",timestamps,fatr,fdir,fname);
	}else{
		sprintf(prbuf,"%s",fname);	//t@ĈPrint.
		if( (nocolumn==0) &&( fd->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) {
			strcat(prbuf,"/");
		}
	}
	push_obuf(prbuf);
}

/**********************************************************************
 *		o @pX ## \ ## t@C ## \
 **********************************************************************
 */
char *catname(char *buf,const char *dir,const char *name)
{
	int len;
	strcpy(buf,dir);
	len = strlen(buf) - 1;
	if( strcmp(buf+len,"\\")!=0 && strcmp(buf+len,"/")!=0 ) {
		strcat(buf,"\\");
	}
	strcat(buf,name);
	strcat(buf,"\\");
	return buf;
}

/**********************************************************************
 *	ċAĂяoɂfBNgƁA\.íj
 **********************************************************************
 *	
 *	 fBNgF}b`Op^i̓t@CjA\tO
 *	߂l
 *   St@C̃TCYvl.
 **********************************************************************
 */
unsigned int dirSpaceSub(  const char *dir,const char *name ,int showmode)
{
	HANDLE	ffh;
	WIN32_FIND_DATA	fd;
	ULONG sp = 0, tsp = 0;
	TCHAR path_buffer[_MAX_PATH];
	char  filename[_MAX_PATH];
	char  dirname[_MAX_PATH];
	int   mode;

	init_obuf();

#ifdef	DEBUG
	printf("dirSpaceSub %s:%s\n",dir,name);
#endif
	strcpy(filename,dir);
	if((showmode & DIRFILE) == DIRONLY) {
		strcat(filename,"*");	//fBNĝ݂ꍇ͑SĂɃ}b`.
	}else{
		strcat(filename,name);
	}
	sjis2TCHAR(filename,path_buffer , _MAX_PATH );

	ffh = FindFirstFile(path_buffer , &fd );

	//===== FindFirst do`while [v̊Jn
	if ( ffh != INVALID_HANDLE_VALUE ) do {		//}b`O.
		if ( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
			// ==== fBNg̏ꍇ.
			if(showmode & DIRONLY) {
				if(	recurse ) {	//ċA~̏ꍇ.
					catname(dirname , dir , u2a(fd.cFileName));
					if(IsOpt('R')||IsOpt('F')) mode = SHOW; else mode = NOSHOW;
					if( (!IsOpt('F')) && (mode & SHOW) ) {
						printf("\nDirectory %s\n",dirname);
					}
					sp = dirSpace( dirname , name , mode );	//ċAĂяo.

					if( IsOpt('d') && (showmode & SHOW)) {	// -dIvV̂.
						init_obuf();
						dirPrint(&fd,dir,sp);	//\̎s.
						flush_obuf();			//ɕ\.
					}

				}else{	//ċA~Ȃ̏ꍇ.
					sp = 0;
					if(showmode & SHOW) {
						dirPrint(&fd,dir,sp);	//\̎s.
					}
				}
				tsp += sp;
			}
		}else{
			// ==== t@C̏ꍇ.
			if(showmode & FILEONLY) {
				sp = fd.nFileSizeLow;
				if(showmode & SHOW) {
					dirPrint(&fd,dir,sp);	//\̎s.
				}
				tsp += sp;
			}
		}
	} while( FindNextFile( ffh, &fd ) != 0);
	//===== FindFirst do`while [v̏I.

	flush_obuf();
	return tsp;
}

/**********************************************************************
 *		
 **********************************************************************
 */
unsigned int dirSpace(  const char *dir,const char *name ,int showmode)
{
	unsigned long sp;

	showmode &= SHOW;	//\/\rbĝݓ`d.

	if(recurse==0) {	//fBNgċA𔺂Ȃꍇ.
		return dirSpaceSub(dir,name,showmode | DIRFILE );
	} else {			//fBNgċA𔺂키ꍇ.
		sp = dirSpaceSub(dir,name,showmode | FILEONLY );
		sp+= dirSpaceSub(dir,name,showmode | DIRONLY  );
		return sp;
	}
}
/**********************************************************************
 *		
 **********************************************************************
 */
int is_absdir(char *s)
{
	return (*s=='\\') || (*s=='/');
}


/**********************************************************************
 *		
 **********************************************************************
 */
static int iskanji1(int c)
{
	c &= 0xff;
	return	((0x81<=c && c<=0x9f)||
			 (0xe0<=c && c<=0xfc));
}


/**********************************************************************
 *		
 **********************************************************************
 */
static int is_wild(char *s)
{
	while(*s) {
		if( (*s=='*')||(*s=='?') ) return 1;
		s++;
	}
	return 0;
}
/**********************************************************************
 *		
 **********************************************************************
 */
static void splitdir(char *dir,char *name,char *s)
{
	char *t=NULL;
	char *p;

	strcpy(dir,s);
	
	p=dir;
	while(*p) {	//pX؂T.
		if(*p=='\\' || *p=='/') t=p;
		if(iskanji1(*p)) p+=2;
		else p++;
	}
	
	if(t==NULL) {	//pX؂蕶Ȃ.(OI)
		strcpy(name,s);
		strcpy(dir,"");
		return ;
	}
	
	//Ō̃pX؂蕶ŕ.
	strcpy(name,t+1);
	t[1] = 0;
}
/**********************************************************************
 *		ls ̃C[`.
 **********************************************************************
 */
int ls1( char *basedir , char *basepat )
{
	HANDLE	ffh;
	WIN32_FIND_DATA	fd;
	TCHAR path_buffer[_MAX_PATH];
	char  filename[_MAX_PATH];
	long	sp = 0;

	if(is_wild(basepat)==0) {	//w肳ꂽt@C̓fBNg???
		strcpy(filename,basedir);
		strcat(filename,basepat);
		sjis2TCHAR(filename,path_buffer , _MAX_PATH );
		ffh = FindFirstFile(path_buffer , &fd );
		if ( ffh != INVALID_HANDLE_VALUE ) {
			if ( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {	// x!!!
				strcat(filename,"\\");
				basedir = filename;
				basepat = "*";
			}
		}else{
			if(basepat[0]==0) {
				basepat = "*";
			}
		}
	}

	sp = dirSpace( basedir ,basepat ,SHOW );

	if( (!IsOpt('1')) && ( recurse || nocolumn ) ) {
		totalPrint(sp);
	}
	return 0 ;
}

/**********************************************************************
 *		.
 **********************************************************************
 */
int main(int argc,char **argv)
{
	TCHAR	MessageBuf[_MAX_PATH] ;
	TCHAR	Tdir[_MAX_PATH] ;
	char	dir[_MAX_PATH] ;
	char 	basedir[_MAX_PATH];
	char 	basepat[_MAX_PATH];
	DWORD	rc;

	GetWH( &ScreenWidth, &ScreenHeight);
	if(ScreenWidth >= ScreenWidthMAX) ScreenWidth = ScreenWidthMAX;
	if(ScreenHeight>= ScreenHeightMAX)ScreenHeight= ScreenHeightMAX;

	Getopt(argc,argv);

	if( IsOpt('h')||IsOpt('?')) Usage();

	if( IsOpt('R')||IsOpt('d')||IsOpt('F') ) recurse = 1;
				if( IsOpt('d') ) Opt('l') = "l";	// -lIvVOn
	if( IsOpt('1')||IsOpt('d')||IsOpt('F')||IsOpt('l') ) nocolumn = 1;
	if( IsOpt('a') ) allattr = 1;

	rc = GetCurDir( _MAX_PATH, Tdir );

	// MessageBuf[] ɁAtPATH̃fBNgp^[.
	if ( argc >= 2 ) {
		if( is_absdir(argv[1]) ) {
			//΃pXw肳ꂽꍇ.
			sjis2TCHAR( argv[1] , MessageBuf ,_MAX_PATH );
		}else{
			//΃pXw肳ꂽꍇ.
			sjis2TCHAR( argv[1] , Tdir ,_MAX_PATH );
			rel2absdir( MessageBuf, _MAX_PATH, Tdir ) ;
		}
	}else{
		//p[^ȗꂽꍇ́A "*" uꂽ̂Ƃ.
		sjis2TCHAR( "*" , Tdir ,_MAX_PATH );
		rel2absdir( MessageBuf, _MAX_PATH, Tdir ) ;
	}

	unicode2sjis(MessageBuf,dir,_MAX_PATH);
	splitdir(basedir,basepat,dir);

#ifdef	DEBUG
	printf("%s:%s\n",basedir,basepat);
#endif
	ls1(basedir,basepat);

	return 0;
}
/**********************************************************************
 *		
 **********************************************************************
 */
