/*=========================================================================
 *
 *
 *
 *=========================================================================
 */
#include	<conslib.h>
#include	<tchar.h>

TCHAR	AppName[] = TEXT("CE_console") ;	/* K{ */
TCHAR	MessageBuf[ 256 ] ;

int Main( DWORD argc, LPTSTR argv[] )
{
	dmain();
//	Cputs( TEXT("Hello,World\n") ) ;
	return 0;
}


/*
 * @́FSJISUnicodeR[hϊ
 * @́Fsjis2unicode
 * @TvFSJISUnicodeɕϊ
 * Fsrc = SJIS
 * @@@Fdst = Unicodei[̈ւ̃|C^
 * @@@Fmax = Unicodei[̈̍őoCg
 * ߂lFDWORD = ϊʂ̃oCg(dst=0͕̎KvoCg)\0܂
 */
int sjis2unicode( const BYTE *src, LPTSTR dst, DWORD max )
{
	DWORD	required, count ;

	required = dst ? max / sizeof (TCHAR) : 0 ;
	count = MultiByteToWideChar( CP_ACP, 0, src, -1, dst, required ) ;
	return count * sizeof (TCHAR) ;
}

//	蔲.
int	vsprintf(char *buf,char *fmt,int *va_list);

int	printf(char *fmt,int arg1, ... )
{
	char buf[1024];
	char Tbuf[1024];

	vsprintf(buf,fmt,&arg1);
	sjis2unicode( buf,Tbuf,1020 );
	Cputs( Tbuf );

	return 1;
}

/**********************************************************************
 *		}NA`
 **********************************************************************
 */
static	char	*vp;
static	void vputc(int c)
{
	*vp++ = c;
}

static	int is_num(int c)
{
	if((c<'0')||(c>'9')) return(-1);
	return(c-'0');
}

/**********************************************************************
 *		oB
 **********************************************************************
 */
static char *getnum(char *s,int *val)
{
	int v,r,sgn;
	v=0;
	sgn=1;
	
	if(*s=='-') {s++;sgn=(-1);}
	
	if(is_num(*s)>=0) {
	   while( (r=is_num(*s)) >=0) {
		v*=10;
		v+=r;
		s++;
	   }
	   *val=v*sgn;
	}
	return(s);
}

/**********************************************************************
 *		Tu[`
 **********************************************************************
 */
static	int hexch(int c,int alp)
{
	if(c>=10)	 c += alp;	/* 'A''a'  */
				 c += '0';
	return(c);
}

static	void hexprint(int val,int column,int radix,int fmt,int filler)
{
	static char hexbuf[32];
	int i,minus=0;
	int alp;
	
	if(fmt=='x') alp=0x27;
	else		 alp=0x07;

	if(radix==10) {
		if(val < 0) {val = -val ; minus=1;}
	}

	i=0;
	do {
		hexbuf[i++] = hexch( (unsigned) val %  radix,alp);
		   			         (unsigned) val /= radix;
	}while(val!=0);

	if(minus && (filler=='0') ) {
		vputc('-');
		while(column>(i+1)) {
			vputc(filler);column--;
		}
	}else{
		if(minus) hexbuf[i++]='-';
		while(column>i) {
			vputc(filler);column--;
		}
	}
	
	while(i>0) {
		vputc(hexbuf[--i]);
	}
}

static	void strprint(char *s,int column)
{
	int	l;
	int slen;
	slen=strlen(s);

	/* ]KvȂ */
	if(   column > slen ) {
		l=column - slen;
		while(l) {
			vputc(' ');l--;
		}
	}

	while(*s) {
		vputc(*s++);
	}

	/* E]KvȂ */
	if( column<0 ) {
	if(   (-column) > slen ) {
		l=(-column) - slen;
		while(l) {
			vputc(' ');l--;
		}
	}
	}
}

static	void chrprint(int c)
{
	vputc(c);
}

/**********************************************************************
 *		ij
 **********************************************************************
 */
int	vsprintf(char *buf,char *fmt,int *va_list)
{
	int  column;
	int  c,filler;
	
	vp=buf;
	
	while(*fmt) {
		if(*fmt=='%') {					/* GXP[v */
			column=1;
			if(fmt[1]=='0') filler='0';
			else		    filler=' ';

			fmt=getnum(fmt+1,&column);	/* ̌̐ => column */
 
 			c = *fmt++;
 			if(c=='l') {
 					c = *fmt++;
 			}
			switch(c) {
			  case 'd':
			  case 'D':
			  	hexprint( *va_list++,column,10,c,filler );break;
			  case 'x':
			  case 'X':
			  	hexprint( *va_list++,column,16,c,filler );break;
			  case 's':
			  	strprint( (char *)*va_list++,column);	   break;
			  case 'c':
			  	chrprint( *va_list++);			   break;
#if	0
			  case 'f':
			  case 'F':
			  case 'g':
			  case 'G':
				dblprint( va_list,c );
#endif
			  case '%':
			  	chrprint( '%' );			   break;
			  default:
			  	break;
			}
		}else{
			if(*fmt == '\n') 
				vputc( '\r');	/* lr-cnr̎dl(CR+LF)Ɉ˂ */
			vputc(*fmt++);
		}
	}
	vputc(0);
	return( vp - buf );		/* o͂Ԃ */
}

/**********************************************************************
 *		
 **********************************************************************
 */

//	.

int fflush()
{

}

int	gets()
{

}

int	sscanf()
{

}
